(function (window, document, undefined) {
	var instance,
	Progress,
  access;

	if (typeof define == 'function') {
    define('xmls', ['pr', 'ac'], function (_Progress, _access) {
      Progress = _Progress;
      access = _access;
      return new xmls();
    })
  } else {
    window.xmls = new xmls();
    Progress = window.Progress;
    access = window.access;
  }

	function getCookie(name) {
		var matches = document.cookie.match(new RegExp(
					"(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"));
		return matches ? decodeURIComponent(matches[1]) : undefined;
	}
	function setCookie(name, value, options) {
		options = options || {};

		var expires = options.expires;

		if (typeof expires == "number" && expires) {
			var d = new Date();
			d.setTime(d.getTime() + expires * 1000);
			expires = options.expires = d;
		}
		if (expires && expires.toUTCString) {
			options.expires = expires.toUTCString();
		}

		value = encodeURIComponent(value);

		var updatedCookie = name + "=" + value;

		for (var propName in options) {
			updatedCookie += "; " + propName;
			var propValue = options[propName];
			if (propValue !== true) {
				updatedCookie += "=" + propValue;
			}
		}

		document.cookie = updatedCookie;
	}

	function serialize(document) {
		var serializer = new XMLSerializer();
		var xmlstr = '<?xml version="1.0" encoding="utf-8"?>\r\n' +
			serializer.serializeToString(document)
			.replace(/<\?.*?\?>/, '')
			.replace(/\r|\n|\t/gim, '')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
			.replace(/ xmlns=".*?"/g, '')
			.replace(/<!--.*?-->/g, '')
			.split(/(<.*?>)/)
			.filter(function (e) {
				return e;
			})
			.map(function (e, i, a) {
				if (/^<[^/].*[^/]>$/.test(e)) { //<tag>
					e = '\r\n' + Array(++this.tab).join('\t') + e;
				}
				if (/^<\//.test(e)) { //</tag>
					if (/^<\/|\/>$/.test(a[i - 1]))
						e = '\r\n' + Array(this.tab).join('\t') + e;
					this.tab--
				}
				if (/\/>$/.test(e)) //<tag/>
					e = '\r\n' + Array(this.tab + 1).join('\t') + e;
				return e;
			}, {
				tab: 0
			})
			.join('')
			.replace(/^\r\n/, '');

		return new Blob([xmlstr], {
			type: 'text/xml; charset=utf-8'
		});
	}

  function sclSerialize(document) {
		var serializer = new XMLSerializer();
		var xmlstr = '<?xml version="1.0" encoding="utf-8"?>\r\n' +
			serializer.serializeToString(document)
			.replace(/<\?.*?\?>/, '')
			.replace(/\r|\n|\t/gim, '')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
			.replace(/(<.*?>)\s+(<.*?>)/g, '$1$2')
      .replace(/ xmlns="\s?"/g, '')
			.replace(/<!--.*?-->/g, '')
			.split(/(<.*?>)/)
			.filter(function (e) {
				return e;
			})
			.map(function (e, i, a) {
				if (/^<[^/].*[^/]>$/.test(e)) { //<tag>
					e = '\r\n' + Array(++this.tab).join('\t') + e;
				}
				if (/^<\//.test(e)) { //</tag>
					if (/^<\/|\/>$/.test(a[i - 1]))
						e = '\r\n' + Array(this.tab).join('\t') + e;
					this.tab--
				}
				if (/\/>$/.test(e)) //<tag/>
					e = '\r\n' + Array(this.tab + 1).join('\t') + e;
				return e;
			}, {
				tab: 0
			})
			.join('')
			.replace(/^\r\n/, '');

		return new Blob([xmlstr], {
			type: 'text/xml; charset=utf-8'
		});
	}

	function xmls() {
		if (instance)
			return instance;
		function setFileInLocalSTR(num, file, callback) {
      var blob = file.slice(0, file.size);
      
      var encoding = 'UTF-8'
      blob.text().then(function(test) {
        var m = test.match(/<\?xml.*encoding="(.*?)".*?\?>/)
        if (m.length > 1) {
          if (m[1].search('1251') > 0) encoding = 'windows-1251'
        }

        var reader = new FileReader();
        reader.onloadend = function (evt) {
          if (evt.target.readyState == FileReader.DONE) {
            localStorage['local_' + num] = evt.target.result;
          }
          callback();
        };
        reader.readAsText(blob, encoding);
      })
		}
		function getFileInLocalSTR(num, callback) {
			var parser = new DOMParser(),
			doc = parser.parseFromString(localStorage['local_' + num], 'text/xml'),
			xml = doc.documentElement;
			setCookie('local_' + num, '0');
			callback(xml);
		}
		function getFileFromServer(num, crc, callback) {
			var query = "type=" + (/\d+/.test(num)
					 ? num == 0
					 ? "cfg"
					 : "coproc&num=" + num
					 : num);
			$.ajax({
				url: window.location.protocol == 'chrome-extension:' && window.parent && window.parent.curIP ? "http://" + window.parent.curIP + "/~cfg_ask_xml?" + query : "/~cfg_ask_xml?" + query,
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				async: !!num,
				success: function (data, status, xhr) {
					if (num == 0)
						exports.TimeOffset = +data.documentElement.querySelector('RealTime>TimeZone').textContent;

          if (xhr && xhr.responseText) {
            var lconf = {crc: crc, cfg: xhr.responseText};
            try{
              localStorage['config'] = JSON.stringify(lconf);
            } catch(e){};
          }
					callback(data.documentElement);
				}
			});
		}
    function checkFileFromServer(num, callback) {
        var config = localStorage['config'];
        $.ajax({
          url: window.location.protocol == 'chrome-extension:' && window.parent && window.parent.curIP ? 'http://' + window.parent.curIP + '/~ask_crc?type="cfg"' : '/~ask_crc?type="cfg"',
          headers: exports.requestHeaders ? exports.requestHeaders : {},
          async: !!num,
          success: function (crc) {
            if (config) {
              config = JSON.parse(config);
              if (config.crc == crc) {
                var parser = new DOMParser(),
                    doc = parser.parseFromString(config.cfg, 'text/xml');
                callback(doc.documentElement);
              } else getFileFromServer(num, crc, callback);
            } else getFileFromServer(num, crc, callback);
          }
        });
    }

		function createDatamapMap(data) {
      var dm = {};
      var sdm = data.split('\r\n');
      sdm = sdm.map(function(e){
        if (e) {
          var c = e.split(/\s+/);
          if (c.length > 4) {
            if (!(c[3] in dm)) dm[c[3]] = {};
            if (!(c[2] in dm[c[3]])) dm[c[3]][c[2]] = {};
            var type = c[4].split('='),
                pth = c[1].split('$');
            if (pth.length) pth = pth[pth.length-1];
            else return;
            var names = c[1].split('$')
            names.splice(1,1);
            names.splice(-1,1);
            dm[c[3]][c[2]][pth] = {
              type: type.length ? type[1] : c[4],
              path: c[1],
              itemName: names,
              iedinst: c[0]
            };
          }
        }
      })
      return dm;
    }

    var types = {'Scl': 'xml', 'Startup': 'text', 'OsiCfg': 'xml', 'LogCfg': 'xml', 'Datamap': 'text', 'Datamapout': 'text'}, countIecFile;
		function getIECFileFromServer(type, callback, done) {
			$.ajax({
				url: "/~cfg_ask_61850?type=" + type,
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				context: type,
				success: function (data) {
					if (types[this] == 'xml') callback(this, data.documentElement, done);
					else {
            if (this == 'Datamap') callback(this + '_map', createDatamapMap(data), done);
            callback(this, data, done);
          }
				},
        error: function () {
          callback(this, null, done);
        }
			});
		}
    var typesWeb = {
      'Scl': {url:'/template/iec61850/BINOM3.cid', type: 'xml'},
      'Startup': {url:'/template/iec61850/startup.cfg', type: 'text'},
      'OsiCfg': {url: '/template/iec61850/osicfg.xml', type: 'xml'},
      'LogCfg': {url: '/template/iec61850/logcfg.xml', type: 'xml'},
      'Datamap': {url: '/template/iec61850/datamap.cfg', type: 'text'},
      'Datamapout': {url: '/template/iec61850/datamapout.cfg', type: 'text'}
    };
		function getIECFileFromWeb(type, callback, done) {
			$.ajax({
				url: typesWeb[type].url,
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				context: type,
				success: function (data) {
					if (typesWeb[this].type == 'xml') {
            var x;
            if (!data.documentElement) {
              var parser = new DOMParser();
              x = parser.parseFromString(data, 'application/xml');
              x = x && x.documentElement ? x.documentElement : null;
            } else x = data.documentElement
            callback(this, x, done);
					} else {
            if (this == 'Datamap') callback(this + '_map', createDatamapMap(data), done);
            callback(this, data, done);
          }
				}
			});
		}
		function getIECFile(callback, web, done) {
      if (typeof web == 'undefined') web = false;
      if (web) {
        for(var t in typesWeb) {
          getIECFileFromWeb(t, callback, done);
        }
      } else {
        for(var t in types) {
          getIECFileFromServer(t, callback, done);
        }
      }
		}

		function getFile(num, callback) {
			if (local[num])
				getFileInLocalSTR(num, callback);
			else
				//getFileFromServer(num, callback);
				checkFileFromServer(num, callback);
		}
		function getUsers(num, callback) {
			$.ajax({
				url: '/~pwd_list',
				headers: exports.requestHeaders ? exports.requestHeaders : {},
				success: function (data) {
					/*data = data.replace(/\r|\n|\t/gim, '')
									.replace(/{(.*?):/g, '{"$1":')
									.replace(/ (.*?):/g, ' "$1":')
									.replace(/,]/g, ']');*/

					var users = JSON.parse(data),
							accs = {},
							docStr = '<KIPP_3><Passwords></Passwords><Access></Access></KIPP_3>',
							parser = new DOMParser(),
							docPass = parser.parseFromString(docStr, 'text/xml');

					var passw = docPass.querySelector('Passwords'),
							acc = docPass.querySelector('Access');

					for (var i = 0; i < users.length; i++) {
						users[i].Access = users[i].Access.split(',');

						var item = docPass.createElement('Item'),
							uid = docPass.createElement('uid'),
							login = docPass.createElement('Login'),
							pass = docPass.createElement('Password'),
							enab = docPass.createElement('Enable'),
							maxConn = docPass.createElement('MaxConnect'),
							wwwRoot = docPass.createElement('WwwRoot');
							//A = docPass.createElement('A');

						login.textContent = users[i].Name;
						enab.textContent = users[i].Enable;
						uid.textContent = users[i].ID;
						maxConn.textContent = users[i].MaxConn;
						wwwRoot.textContent = users[i].Dir;
						//A.textContent = u.join(',');

						item.appendChild(uid);
						item.appendChild(login);
						item.appendChild(pass);
						item.appendChild(enab);
						item.appendChild(maxConn);
						item.appendChild(wwwRoot);
						//item.appendChild(A);
						if (login.textContent != 'root') {
							passw.appendChild(item);
						}
						for (var j = 0; j < users[i].Access.length; j++) {
							if (!(users[i].Access[j] in accs)) accs[users[i].Access[j]] = [];
							if (accs[users[i].Access[j]].indexOf(uid.textContent) < 0) accs[users[i].Access[j]].push(uid.textContent);
						}
					}
					for(var ac in accs) {
						var item = docPass.createElement('Item'),
							name = docPass.createElement('Name'),
							list = docPass.createElement('List'),
							pass;

						name.textContent = ac;
						list.textContent = accs[ac].join(',');

						item.appendChild(name);
						item.appendChild(list);
						acc.appendChild(item);

						/*if (ac == 'tu' || ac == 'restart') {
							pass = docPass.createElement('Password');
							pass.textContent = '#*#'
							item.appendChild(pass);
						}*/
					}
					callback(docPass.documentElement);
				}
			});
		}
		function setXMLS(num, xml) {
			xmls[num] = xml;
			if (num < 11 && xmls[0].getAttribute('prm_type') == 'TM3COM') {
				getFile(++num, setXMLS.bind(null, num));
			}
		}

		function setIEC(type, data, done) {
      countIecFile--;
      if (data != null) {
        if (!('iec' in xmls)) xmls['iec'] = {};
        xmls['iec'][type] = data;
      }
      if (!countIecFile) done();
		}

		var xmls = window['xmls'] = {},
			local = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10].map(function (i) {
				return !!(getCookie('local_' + i) * 1);
			});

		getFile(0, setXMLS.bind(null, 0));

    var userName;
    if (access) userName = access.name;
    else {
      userName = document.querySelector('#userinfo .name');
      if (userName) userName = userName.textContent;
    }
    if (userName == 'root') getUsers('passw', setXMLS.bind(null, 'passw'));

		Object.defineProperty(xmls, 'save', {
			enumerable: false,
			value: function (num, callback, options, context) {
				function send(num, success) {
					var data = serialize(xmls[num].ownerDocument),
					saveToLocal = document.querySelector('#gears #saveform_local').checked,
					saveToDevice = document.querySelector('#gears #saveform_device').checked,
					result = saveToLocal * 1 + saveToDevice * 1;

					function checkResult() {
						if (--result == 0) {
							success();
						}
					}

					if (saveToLocal) {
						window.URL = window.webkitURL || window.URL;

						var a = document.createElement('a');
						a.download = 'config' + (num * 1 ? '_' + num : '') + '.xml';
						a.href = window.URL.createObjectURL(data);
						a.type = 'text/xml; charset=utf-8';
						a.click();
						window.URL.revokeObjectURL(a.href);
						checkResult();
					}

					if (saveToDevice) {
						var formData = new FormData();
						var query = "type=" + (/\d+/.test(num)
								 ? num == 0
								 ? "cfg"
								 : "coproc&num=" + num
								 : num);
						formData.append("config", data, 'config.xml');
						$.ajax({
							type: "POST",
							url: window.location.protocol == 'chrome-extension:' && window.parent && window.parent.curIP ? 'http://' + window.parent.curIP + '/~cfg_send_xml?' + query : '/~cfg_send_xml?' + query,
							dataType: "text",
							success: checkResult,
							error: checkResult,
							contentType: false,
							processData: false,
							data: formData,
							headers: exports.requestHeaders || {}
						});
					}
				}

				function waitCallback() {
					if (num !== undefined) {
						if (result === null) {
							setTimeout(waitCallback, 100)
						} else {
							callback && callback.apply(context, options);
						}
					} else {
						var ready = !Object.keys(result).some(function (key) {
								return !result[key] === null;
							})
							if (!ready) {
								setTimeout(waitCallback, 100);
								return;
							}
							callback && callback.apply(context, options);
					}
				}

				function success(data) {
					result[i] = true;
					result[i++] = null;
					if (xmls_nums[i] == 'iec') i++; // пропускаю passw
					(i < xmls_nums.length) && send(xmls_nums[i], success, error);
				}

				function error(error) {
					result[i] = false;
					result[i++] = null;
					(i < xmls_nums.length) && send(xmls_nums[i], success, error);
				}

				var result,
				xmls_nums = Object.keys(xmls),
				i = 0;

				if (num == undefined) {
					result = {};
					xmls_nums.length &&
					send(xmls_nums[i], success, error);
				} else {
					num = '' + num;
					result = null;

					~xmls_nums.indexOf(num) &&
					send(num,
						function (data) {
						result = true
					},
						function (error) {
						result = false
					})
				}

				waitCallback();
			}
		});

    Object.defineProperty(xmls, 'saveIec', {
			enumerable: false,
			value: function (done) {
        var countFile = Object.keys(types).length;
        function checkResult() {
          if (--countFile == 0) {
            done();
          }
        }

        function saveIecFile (type) {
          var data = types[type] == 'xml' ? sclSerialize(xmls.iec[type].ownerDocument) : new Blob([xmls.iec[type]], {type: 'text'});
          var formData = new FormData();

          formData.append(type, data, type);
          $.ajax({
            type: "POST",
            url: "/~cfg_new_61850?type=" + type,
            dataType: "text",
            success: checkResult,
            error: checkResult,
            contentType: false,
            processData: false,
            data: formData,
            headers: exports.requestHeaders || {}
          });
        }

        //сохраняю только если не локально
        if(document.querySelector('#gears #saveform_device').checked){
          for(var t in types) {
            saveIecFile(t);
          }
        }
      }
    })

		Object.defineProperty(xmls, 'local', {
			enumerable: false,
			value: function (num, file, callback) {
				var name = file.name;
				setCookie('local_' + num, '1');
				FS(setFileInFs.bind(null, num, file, callback, null));
			}
		})

		Object.defineProperty(xmls, 'load', {
			enumerable: false,
			value: function (callback) {
				var ready = 11;
				function checkReady() {
					if (!--ready) {
						callback();
					}
				}
				[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10].forEach(function (num) {
					var local = document.querySelector('#gears #loadform_local_' + num),
					files = local && local.files;
					if (!files || !files.length)
						return checkReady();

					setFileInLocalSTR(num, files[0], checkReady);
					setCookie('local_' + num, '1');
				});
			}
		})

		var handleImportFileSelect = function(evt){
			files = evt.target.files;
			if (!files.length) return;

			var reader = new FileReader();
			reader.onload = function() {
				var tXml = reader.result,
					parser = new DOMParser(),
					doc;

				try{
					doc = parser.parseFromString(tXml, 'text/xml');
				}catch(e){
					//косяк
				}
				var newTariff = doc.querySelector('Tariff');
				if (newTariff) {
					var tariff = xmls[0].querySelector('ASKUE>Tariff'),
							askue = tariff.parentElement
					askue.removeChild(tariff);
					askue.appendChild(newTariff);
					setFileInLocalSTR(0, serialize(xmls[0]), function(){
						setCookie('local_0', '1');
						setTimeout(location.reload.bind(location),100)
					});
				} else {
					//косяк
				}
			}
			reader.readAsText(files[0]);
		}

		Object.defineProperty(xmls, 'importTariff', {
			enumerable: false,
			value: function () {
				var inp = document.createElement('input');
				inp.type = 'file';
				inp.addEventListener('change', handleImportFileSelect, false);
				inp.accept = '.xml';
				inp.click();
			}
		});

		Object.defineProperty(xmls, 'exportTariff', {
			enumerable: false,
			value: function (doc, serial) {
					var data = serialize(doc);

					window.URL = window.webkitURL || window.URL;

					var a = document.createElement('a');
					a.download = 'tarrifs_' + serial + '.xml';
					a.href = window.URL.createObjectURL(data);
					a.type = 'text/xml; charset=utf-8';
					a.click();
					window.URL.revokeObjectURL(a.href);
			}
		});

		Object.defineProperty(xmls, 'getIEC', {
			enumerable: false,
			value: function (web, done) {
          countIecFile = Object.keys(types).length;
					getIECFile(setIEC, web, done);
			}
		});

    Object.defineProperty(xmls, 'saveCid', {
			enumerable: false,
			value: function (web, done) {
        if (xmls.iec && xmls.iec.Scl) {
          //xmls.iec.Scl.setAttribute && xmls.iec.Scl.setAttribute('xmlns', 'http://www.iec.ch/61850/2003/SCL');
					var data = sclSerialize(xmls.iec.Scl);

					window.URL = window.webkitURL || window.URL;

					var a = document.createElement('a');
					a.download = 'BINOM3.cid';
					a.href = window.URL.createObjectURL(data);
					a.type = 'text/xml; charset=utf-8';
					a.click();
					window.URL.revokeObjectURL(a.href);
        }
			}
		});

    Object.defineProperty(xmls, 'updateDatamap', {
			enumerable: false,
			value: function () {
        if (this.iec) {
					this.iec.Datamap_map = createDatamapMap(this.iec.Datamap);
        }
			}
		});
    Object.defineProperty(xmls, 'mapToDatamap', {
			enumerable: false,
			value: function () {
        if (this && this.iec && this.iec.Datamap) {
          var ied = this.iec.Scl.querySelector('IED'),
              lDev = this.iec.Scl.querySelector('IED>AccessPoint>Server>LDevice');
					var iedName = ied ? ied.getAttribute('name') : 'BINOM3',
              inst = lDev ? lDev.getAttribute('inst') : 'C1',
              dm = this.iec.Datamap_map,
              dmstr = '';

            for (chan in dm) {
              for (item in dm[chan]) {
                for (type in dm[chan][item]) {
                  var el = dm[chan][item][type];
                  el.iedinst = (el.iedinst.trim()[0] == '#' ? '#' : '') + iedName + inst;
                  dmstr += el.iedinst + '\t' + el.path + '\t\t\t\t\t\t' + item + '\t\t' + chan + '\t\ttype=' + el.type + '\r\n';
                }
              }
            }
            if (dmstr) xmls.iec.Datamap = dmstr;
        }
			}
		});

    Object.defineProperty(xmls, 'serialize', {
			enumerable: false,
      value: serialize
    });
		return instance = xmls;
	}
})(window, document, undefined);
